authentication/urls.py
from django.urls import path

from . import views

app_name = 'authentication'

urlpatterns = [
    path('', views.index, name='index'),
    path('login', views.login, name='login'),
    path('logout', views.logout, name='logout'),
    path('register', views.register, name='register'),
]

e6_siruco/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('', include('hanif.urls')),
    path('authentication/', include('authentication.urls')),
    path('transaksi-makan/', include('transaksi_makan.urls')),
    path('paket-makan/', include('paket_makan.urls')),
    path('hotel/', include('hotel.urls')),
    path('jadwal-dokter/', include('jadwal_dokter.urls')),
    path('daftar-pasien/', include('daftar_pasien.urls')),
    path('appointment/', include('appointment.urls')),
    path('faskes/', include('faskes.urls')),
    path('jadwal_faskes/', include('jadwal_faskes.urls')),
    path('rumahsakit/', include('rumahsakit.urls')),
    path('reservasiRS/', include('reservasiRS.urls')),
    path('transaksirs/', include('transaksirs.urls')),
    path('ruangan-rs/', include('ruangan_rs.urls')),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
]

authentication/models.py
from django.db import models

# Create your models here.

authentication/views.py
from django.shortcuts import render, redirect
from django.db import connection
from django.db.utils import IntegrityError, InternalError
from django.contrib import messages
import traceback

# Create your views here.
def index(request):
    return render(request, 'authentication/index.html')

def login(request):
    if request.session.get("username", False):
        return redirect("authentication:index")

    if request.method == "POST":
        with connection.cursor() as cursor:

            # ini buat execute query database
            cursor.execute(f"""
                SELECT * FROM AKUN_PENGGUNA
                WHERE username='{request.POST["username"]}'
                AND password='{request.POST["password"]}'
                """)

            row = cursor.fetchall() # ini dibalikin dalem bentuk multi-dimensional array
            if (len(row) != 0): # Berhasil login

                # contohnya buat set session.username menjadi row pertama (index ke 0) kolom pertama (index ke 0)
                # dalem kasus gw, kolom username adalah kolom paling awal di table PENGGUNA
                request.session["username"] = row[0][0] 
                request.session["password"] = row[0][1] 
                request.session["peran"] = row[0][2] 
                return redirect("main:home")

            else: # Gagal login
                messages.add_message(request, messages.WARNING, "Maaf, username atau password salah.")

    return render(request, "authentication/index.html")

def register(request):
    if request.session.get("username", False):
        return redirect("main:home")

    if request.method == "POST":
        with connection.cursor() as cursor:
            try:
                cursor.execute(f"""
                    SELECT FROM AKUN_PENGGUNA WHERE username = '{request.POST["username"]}'
                """)

                if (len(cursor.fetchall()) == 0):
                    cursor.execute(f"""
                        INSERT INTO AKUN_PENGGUNA (username, password, peran) VALUES
                        ('{request.POST["username"]}', '{request.POST["password"]}', '{request.POST["peran"]}')
                    """)

                peran = {request.POST["peran"]}
                if (peran == {'admin sistem'}):
                    cursor.execute(f"""
                        INSERT INTO ADMIN (username) VALUES
                        ('{request.POST["username"]}')
                    """)

                elif (peran == {'pengguna publik'}):
                    cursor.execute(f"""
                        INSERT INTO PENGGUNA_PUBLIK (username, nik, nama, status, peran, nohp) VALUES
                        ('{request.POST["username"]}', '{request.POST["nik"]}', '{request.POST["nama"]}', 'AKTIF', '{request.POST["peran2"]}', '{request.POST["no_hp"]}')
                    """)

                elif (peran == {'dokter'}):
                    cursor.execute(f"""
                        INSERT INTO ADMIN (username) VALUES
                        ('{request.POST["username"]}')
                    """)
                    cursor.execute(f"""
                        INSERT INTO DOKTER (username, nostr, nama, nohp, gelardepan, gelarbelakang) VALUES
                        ('{request.POST["username"]}', '{request.POST["no-str"]}', '{request.POST["nama"]}', '{request.POST["no-hp"]}', 
                        '{request.POST["gelar-depan"]}', '{request.POST["gelar-belakang"]}')
                    """)

                elif (peran == {'admin satgas'}):
                    cursor.execute(f"""
                        INSERT INTO ADMIN (username) VALUES
                        ('{request.POST["username"]}')
                    """)
                    cursor.execute(f"""
                        INSERT INTO admin_satgas (username, idfaskes) VALUES
                        ('{request.POST["username"]}', '{request.POST["kode"]}')
                    """)


                messages.add_message(request, messages.SUCCESS, f"Registrasi berhasil, silahkan login")
                messages.add_message(request, messages.SUCCESS, f"{request.POST['username']}")

                return render(request, "authentication/register.html")
            
            # Ada username yang sama, handle disini
            except InternalError:
                messages.add_message(request, messages.WARNING, f'''Password Anda belum memenuhi syarat, silahkan 
                pastikan bahwa password minimal terdapat 1 huruf kapital dan 1 angka''')
            except IntegrityError:
                messages.add_message(request, messages.WARNING, f"Username {request.POST['username']} sudah ada")
            except:
                traceback.print_exc()
                print(request.POST.get("kode", False))
                messages.add_message(request, messages.WARNING, f"Ada gangguan server internal, mohon coba lagi")

    with connection.cursor() as cursor:
        cursor.execute(f"""
            SELECT kode FROM FASKES
        """)
        row = cursor.fetchall()
        context = []
        for i in range(len(row)):
            context.append(row[i][0])

    return render(request, "authentication/register.html", {'context':context})


def logout(request):
    # Hilangkan semua dari session
    request.session.pop("username", None)
    request.session.pop("password", None)
    request.session.pop("peran", None)

    return redirect("authentication:index")

authentication/templates/authentication/index.html
<!DOCTYPE HTML>
{% extends 'base.html' %}
{% load static %}
<html>
    <head>
      {% block meta %}
      <link rel="stylesheet" href="{% static 'authentication/style.css' %}">

      <title>Siruco - Login</title>
      {% endblock meta %}
    </head>

    <body class="{% block class_meta %}login-container{% endblock class_meta %}">
      {% block log_but %}disabled{% endblock log_but %}

      {% block content %}
      <div class="container">
        <div class="row"></div>
        <div class="row align-items-center">
          <div class="col"></div>
          <div class="col-6">
            <form method="POST" action="{% url 'authentication:login' %}">
              {% csrf_token %}
              <figure class="text-center">
                <h3>Siruco - Login</h3>
              </figure>
              <div class="mb-3">
                <label for="usernameInput" class="form-label">Username</label>
                <input type="text" class="form-control" name="username" id="usernameInput" placeholder="Username" required>
              </div>

              <div class="mb-3">
                <label for="passwordInput" class"form-label">Password</label>
                <input type="password" class="form-control" name="password" id="passwordInput" placeholder="Password" required>
              </div>

              <figure class="text-center">
                {% for message in messages %}
                {{ message }}
                <br>
                {% endfor %}

                <button type="submit" class="btn btn-outline-success">Login</button>

                <p>Belum punya akun? <a href="{% url 'authentication:register' %}">Register</a></p>

                {% if request.session.username %}
                <h1>Berhasil {{ request.session.username }} {{ request.session.peran }}</h1>
                <a href={% url 'authentication:logout' %}>logout</a>
                {% endif %}
              </figure>
            </form>
          </div>
          <div class="col"></div>
        </div>
      </div>
      {% endblock content %}
      
    </body>
</html>

authentication/templates/authentication/register.html
<!DOCTYPE HTML>
{% extends 'base.html' %}
<html>
  {% load static %}
    <head>
      {% block meta %}
      <script src={% static 'authentication/script.js' %}></script>
      {% endblock meta %}
    </head>

    <body>
      {% block reg_but %}disabled{% endblock reg_but %}
      {% block content %}
      <div class="container">
        <div class="row"></div>
        <div class="row align-items-center">
          <div class="col"></div>
          <div class="col-6">
            <form method="POST" action="{% url 'authentication:register' %}" class="">
            {% csrf_token %}
            <figure class="text-center">
              <h3>Siruco - Registrasi</h3>
            </figure>

            <div class="mb-3">
              <label for="username" class="form-label">Username</label>
              <input type="username" id="username" name="username" class="form-width form-control" aria-describedby="emailHelp" placeholder="Username" required>
            </div>

            <div class="mb-3">
              <label for="password" class="form-label">Password</label>
              <input type="password" id="password" name="password" class="form-width form-control" placeholder="Password" required>
            </div>

            <p>Peran</p>

            <div class="form-check form-check-inline">
              <input class="form-check-input" type="radio" name="peran" id="admin" value="admin sistem" onclick="check()">
              <label class="form-check-label" for="admin">Admin Sistem</label>
            </div>

            <div class="form-check form-check-inline">
              <input class="form-check-input" type="radio" name="peran" id="pengguna-publik" value="pengguna publik" onclick="check()">
              <label class="form-check-label" for="pengguna-publik">Pengguna Publik</label>
            </div>

            <div class="form-check form-check-inline">
              <input class="form-check-input" type="radio" name="peran" id="dokter" value="dokter" onclick="check()">
              <label class="form-check-label" for="dokter">Dokter</label>
            </div>

            <div class="form-check form-check-inline">
              <input class="form-check-input" type="radio" name="peran" id="admin-satgas" value="admin satgas" onclick="check()">
              <label class="form-check-label" for="admin-satgas">Admin Satgas</label>
            </div>

            <div id="form-tambahan">
            </div>

            <select class="form-select" name="kode" aria-label="Default select example" id='form-admin-satgas' style="display: none;">
              <option>Faskes</option>
              {% for kode in context %}
              <option value="{{kode}}">{{ kode }}</option>
              {% endfor %}
            </select>
            <br>

            <figure class="text-center">
              {% for message in messages %}
              {{ message }}
              <br>
              {% endfor %}
              <button type="submit" class="btn btn-outline-primary">Register</button>

              <br><br>
              <p>Sudah punya akun? <a href="{% url 'authentication:index' %}">Login</a></p>
            </figure>
          </form>
        </div>
        <div class="col"></div>
      </div>
    </div>

      
    {% endblock content %}
      
    </body>
</html>